--	Controllable Rockets script

--	(made by Alistaire)

--[[

CONFIG FILE IS CALLED CR_Config.lua!

	You can find custom CR_Config files in CR_Config_Examples.
	To make the script use a different config file, edit 'customloc' to the name of the config.
	
	!- YOU CAN OPEN AND EDIT .CON FILES WITH NOTEPAD -!

--]]

customloc		=		'customloc'

if io.open('sys/lua/CR_Config_Examples/CR_'..customloc..'.con') then
	dofile('sys/lua/CR_Config_Examples/CR_'..customloc..'.con')
else
	dofile('sys/lua/CR_Config.lua')
end

function A()
	local c = {}
	for i = 1, 32 do
		c[i] = 0
	end
	return c
end

function B(a, b)
	for _result, _b in pairs(a) do
		if _b == b then
			return _result
		end
	end
end

CR_afterburn	=		A()
CR_armor		=		A()
CR_exppos		=		A()
CR_image		=		A()
CR_imagerckt	=		A()
CR_last			=		A()
CR_prevpos		=		A()
CR_rocket 		= 		A()
CR_save			=		A()
CR_timer 		= 		A()

for i = 1, 32 do CR_prevpos[i] = {0, 0} CR_exppos[i] = {0, 0} end

addhook('always', 		'CR_always')
addhook('attack',		'CR_attack')
addhook('attack2', 		'CR_attack2')
addhook('bombdefuse',	'CR_bombdefuse')
addhook('dominate',		'CR_dominate')
addhook('hit', 			'CR_hit')
addhook('ms100', 		'CR_ms100')
addhook('spawn',		'CR_spawn')
addhook('walkover',		'CR_walkover')

function CR_always()
	for _, id in pairs(player(0, 'table')) do
		if CR_rocket[id] == 1 then
			if player(id, 'health') > 0 then
				local Angle = math.rad(player(id, 'rot'))
				local x = player(id, 'x') + math.sin(Angle) * CR_speed
				local y = player(id, 'y') - math.cos(Angle) * CR_speed
				if x > 0 and y > 0 and x < (map('xsize') + 1) * 32 and y < (map('ysize') + 1) * 32 then
					parse('setpos '..id..' '..x..' '..y)
				end
				if CR_noclip == 0 then
					if tile(player(id, 'tilex'), player(id, 'tiley'), 'wall') then
						CR_explode(id)
					end
				end
			end
		end
	end
end

function CR_attack(id)
	if CR_detonate == 1 or CR_detonate == 3 then
		if CR_rocket[id] == 1 then
			CR_explode(id)
		end
	end
end

function CR_attack2(id)
	local x = player(id, 'x')
	local y = player(id, 'y')
	if player(id, 'weapontype') == CR_weapon then
		if CR_rocket[id] ~= 1 then
			CR_save[id] = {}
			CR_last[id] = player(id, 'weapontype')
			CR_armor[id] = player(id, 'armor')
			for a, b in pairs(playerweapons(id)) do
				CR_save[id][a] = b
			end
			parse('strip '..id)
			CR_rocket[id] = 1
			CR_afterburn[id] = 1
			CR_prevpos[id][1] = x
			CR_prevpos[id][2] = y
			CR_image[id] = image('gfx/CR/player.png', x, y, 1)
			imagepos(CR_image[id], x, y, player(id, 'rot'))
			CR_imagerckt[id] = image('gfx/CR/rocket.png', 1, 0, id + 200)
			parse('equip '..id..' 84')
			parse('speedmod '..id..' -100')
		else
			if CR_detonate == 2 or CR_detonate == 3 then
				CR_explode(id)
			end
		end
	end
end

function CR_bombdefuse(id)
	if CR_rocket[id] == 1 then
		return 1;
	end
end

function CR_dominate(id)
	if CR_rocket[id] == 1 then
		return 1;
	end
end

function CR_explode(id)
	freeimage(CR_image[id])
	freeimage(CR_imagerckt[id])
	CR_exppos[id][1] = player(id, 'x')
	CR_exppos[id][2] = player(id, 'y')
	CR_rocket[id] = 0
	parse('setpos '..id..' '..CR_prevpos[id][1]..' '..CR_prevpos[id][2])
	parse('explosion '..CR_exppos[id][1]..' '..CR_exppos[id][2]..' '..CR_size..' '..CR_damage..' '..id)
	CR_timer[id] = 0
	CR_afterburn[id] = 0
	for i = 1, 100 do
		if B(CR_save[id], i) then
			parse('equip '..id..' '..i)
			parse('setweapon '..id..' '..CR_last[id])
			parse('setarmor '..id..' '..CR_armor[id])
			parse('speedmod '..id..' 0')
		end
	end
end

function CR_hit(id, source)
	if CR_rocket[id] == 1 then
		CR_explode(id)
		return 1;
	end
	if CR_rocket[source] == 1 then
		return 1;
	end
end

function CR_ms100()
	local CR_maxarch = CR_maxtimer / 2 - (CR_arch_uptime / 2) + (CR_arch_downtime / 2)
	for id = 1, 32 do
		if CR_rocket[id] == 1 then
			function smoke(id)
				parse('effect \"smoke\" '..player(id, 'x')..' '..player(id, 'y')..' '..CR_smoke_ammount..' '..CR_smoke_radius)
			end
			if CR_afterburn[id] == 1 then
				if math.random(1, CR_fire_chance) == 1 then
					parse('effect \"fire\" '..player(id, 'x')..' '..player(id, 'y')..' '..CR_fire_ammount..' '..CR_fire_radius)
				end
				if CR_smoke_times == 1 then
					timer(50, 'smoke', id)
				elseif CR_smoke_times == 2 then
					timer(33, 'smoke', id)
					timer(66, 'smoke', id)
				elseif CR_smoke_times == 3 then
					timer(50, 'smoke', id)
					timer(80, 'smoke', id)
					timer(130, 'smoke', id)
				end
			end
			if CR_timer[id] == 0 and CR_arch == 1 then
				tween_scale(CR_imagerckt[id], (CR_arch_uptime * 100), CR_arch_scale, CR_arch_scale)
			end
			CR_timer[id] = CR_timer[id] + 1
			if CR_timer[id] == CR_maxtimer then
				CR_explode(id)
			end
			if CR_timer[id] == CR_maxarch and CR_arch == 1 then
				if CR_arch_afterburn == 0 then
					CR_afterburn[id] = 0
				end
			end
			if CR_timer[id] == (CR_maxtimer - CR_arch_downtime) and CR_arch == 1 then
				tween_scale(CR_imagerckt[id], (CR_arch_downtime * 100), 0.8, 0.8)
			end
		end
	end
end

function CR_spawn()
	for id = 1, 32 do
		CR_rocket[id] = 0
		CR_timer[id] = 0
		freeimage(CR_image[id])
		freeimage(CR_imagerckt[id])
	end
end

function CR_walkover(id)
	if CR_rocket[id] == 1 then
		return 1;
	end
end